%global dlrn_nvr networking-ovn-6.0.1.dev130-0.20200116080451.e669382
%global dlrn 1
%define upstream_version 6.0.1.dev130
%{lua: posix.setenv("RHEL_ALLOW_PYTHON2_FOR_BUILD",1)}
# Macros for py2/py3 compatibility
%if 0%{?fedora} || 0%{?rhel} > 7
%global pyver %{python3_pkgversion}
%else
%global pyver 2
%endif
%global pyver_bin python%{pyver}
%global pyver_sitelib %python%{pyver}_sitelib
%global pyver_install %py%{pyver}_install
%global pyver_build %py%{pyver}_build
# End of macros for py2/py3 compatibility
%global drv_vendor OVN
%global pkgname networking-ovn
%global srcname networking_ovn
%global docpath doc/build/html

%{!?upstream_version: %global upstream_version %{version}%{?milestone}}
%global with_doc 0

Name:           python-%{pkgname}
Version: 6.0.1
Release: 0.20200116080451.e669382%{?dist}
Summary:        %{drv_vendor} OpenStack Neutron driver

License:        ASL 2.0
URL:            https://pypi.python.org/pypi/%{pkgname}
Source0: networking-ovn-6.0.1.dev130-0.20200116080451.e669382.tar.gz
#
# patches_ignore=DROP-IN-RPM
# patches_base=e669382b251b5fec28dba8e40a03c7b8f23f51d3
Patch0001: 0001-Change-passed-domain_name-parameter-value.patch

#

Source1:        networking-ovn-metadata-agent.service
#

BuildArch:      noarch

%description
OVN provides virtual networking for Open vSwitch and is a component of the
Open vSwitch project.

%package -n     python%{pyver}-%{pkgname}
Summary:        %{drv_vendor} OpenStack Neutron driver
%{?python_provide:%python_provide python%{pyver}-%{pkgname}}

BuildRequires:  git
BuildRequires:  python%{pyver}-devel
BuildRequires:  python%{pyver}-debtcollector
BuildRequires:  python%{pyver}-mock
BuildRequires:  openstack-macros

# This is required to generate the networking-ovn.ini configuration file
BuildRequires:  python%{pyver}-neutron

BuildRequires:  python%{pyver}-oslo-config
BuildRequires:  python%{pyver}-oslo-log
BuildRequires:  python%{pyver}-ovsdbapp
BuildRequires:  python%{pyver}-pbr

%if 0%{?with_doc}
BuildRequires:  python%{pyver}-openstackdocstheme
BuildRequires:  python%{pyver}-sphinx
%endif

# python-openvswitch is not included in openstack-neutron-common.
# Its needed by networking-ovn.
Requires:       openstack-neutron-common >= 1:13.0.0
Requires:       python%{pyver}-babel >= 2.3.4
Requires:       python%{pyver}-futurist >= 1.2.0
Requires:       python%{pyver}-netaddr >= 0.7.18
Requires:       python%{pyver}-neutron-lib >= 1.25.0
Requires:       python%{pyver}-oslo-config >= 2:5.2.0
Requires:       python%{pyver}-octavia-lib >= 1.1.1
Requires:       python%{pyver}-openvswitch >= 2.8.0
Requires:       python%{pyver}-pbr >= 2.0.0
Requires:       python%{pyver}-six >= 1.10.0
Requires:       python%{pyver}-tenacity >= 4.4.0
Requires:       python%{pyver}-ovsdbapp >= 0.10.0
Requires:       python%{pyver}-pyOpenSSL >= 17.1.0
Requires:       python%{pyver}-sqlalchemy >= 1.2.0

%description -n     python%{pyver}-%{pkgname}
OVN provides virtual networking for Open vSwitch and is a component of the
Open vSwitch project.

This package contains %{drv_vendor} networking driver which provides
integration between OpenStack Neutron and OVN.


%package -n     python%{pyver}-%{pkgname}-metadata-agent
Summary:        networking-ovn metadata agent
%{?python_provide:%python_provide python%{pyver}-%{pkgname}-metadata-agent}

BuildRequires:  systemd
Requires:       python%{pyver}-%{pkgname} = %{version}-%{release}
Requires:       openvswitch >= 2.8.0
Requires:       haproxy >= 1.5.0
%if 0%{?rhel} && 0%{?rhel} < 8
%{?systemd_requires}
%else
%{?systemd_ordering} # does not exist on EL7
%endif

%description -n     python%{pyver}-%{pkgname}-metadata-agent
OVN provides virtual networking for Open vSwitch and is a component of the
Open vSwitch project.

This package contains the agent that implements the metadata proxy so that VM's
can retrieve metadata from OpenStack Nova.

%package -n     python%{pyver}-%{pkgname}-migration-tool
Summary:        networking-ovn ML2/OVS to OVN migration tool
%{?python_provide:%python_provide python%{pyver}-%{pkgname}-migration-tool}

Requires:       python%{pyver}-%{pkgname} = %{version}-%{release}

%description -n     python%{pyver}-%{pkgname}-migration-tool
This package provides the necessary tools to update an existing ML2/OVS
OpenStack to OVN based backend.

%prep
%autosetup -n %{pkgname}-%{upstream_version} -S git

# Let's handle dependencies ourselves
%py_req_cleanup

# Kill egg-info in order to generate new SOURCES.txt
rm -rf {srcname}.egg-info


%build
export SKIP_PIP_INSTALL=1
%{pyver_build}

%if 0%{?with_doc}
sphinx-build-%{pyver} -b html doc/source %{docpath}
rm -rf %{docpath}/.{doctrees,buildinfo}
%endif

# Generate config file
PYTHONPATH=. oslo-config-generator-%{pyver} --namespace networking_ovn --output-file networking-ovn.ini
PYTHONPATH=. oslo-config-generator-%{pyver} --namespace networking_ovn.metadata.agent --output-file networking-ovn-metadata-agent.ini


%install
%{pyver_install}

# Remove unused files
rm -rf %{buildroot}%{pyver_sitelib}/bin
rm -rf %{buildroot}%{pyver_sitelib}/doc
rm -rf %{buildroot}%{pyver_sitelib}/tools


# Move config file to proper location
install -d -m 755 %{buildroot}%{_sysconfdir}/neutron/plugins/networking-ovn
mv networking-ovn.ini %{buildroot}%{_sysconfdir}/neutron/plugins/networking-ovn
mv networking-ovn-metadata-agent.ini %{buildroot}%{_sysconfdir}/neutron/plugins/networking-ovn
chmod 640 %{buildroot}%{_sysconfdir}/neutron/plugins/*/*.ini

# Create configuration directories for all services that can be populated by users with custom *.conf files
mkdir -p %{buildroot}/%{_sysconfdir}/neutron/conf.d/networking-ovn-metadata-agent

# Install systemd units
install -p -D -m 644 %{SOURCE1} %{buildroot}%{_unitdir}/networking-ovn-metadata-agent.service

%post -n python%{pyver}-%{pkgname}-metadata-agent
%systemd_post networking-ovn-metadata-agent.service


%preun -n python%{pyver}-%{pkgname}-metadata-agent
%systemd_preun networking-ovn-metadata-agent.service


%postun -n python%{pyver}-%{pkgname}-metadata-agent
%systemd_postun_with_restart networking-ovn-metadata-agent.service

%files -n python%{pyver}-%{pkgname}
%license LICENSE
%if 0%{?with_doc}
%doc %{docpath}
%endif
%{pyver_sitelib}/%{srcname}
%{pyver_sitelib}/%{srcname}-*.egg-info
%{_bindir}/neutron-ovn-db-sync-util
%dir %{_sysconfdir}/neutron/plugins/networking-ovn
%config(noreplace) %attr(0640, root, neutron) %{_sysconfdir}/neutron/plugins/networking-ovn/networking-ovn.ini

%files -n python%{pyver}-%{pkgname}-metadata-agent
%license LICENSE
%{_bindir}/networking-ovn-metadata-agent
%{_unitdir}/networking-ovn-metadata-agent.service
%config(noreplace) %attr(0640, root, neutron) %{_sysconfdir}/neutron/plugins/networking-ovn/networking-ovn-metadata-agent.ini
%dir %{_sysconfdir}/neutron/conf.d/networking-ovn-metadata-agent

%files -n python%{pyver}-%{pkgname}-migration-tool
%license LICENSE
%{_bindir}/networking-ovn-migration-mtu
%{_bindir}/ovn_migration.sh
%{_datadir}/ansible/networking-ovn-migration/playbooks/

%changelog
* Thu Jan 16 2020 OSP Prod Chain <dev-null@redhat.com> 6.0.0-1
- Update patches
- Set binding profile directly from OVNTrunkDriver (redo cont.)

* Wed Jan 08 2020 OSP Prod Chain <dev-null@redhat.com> 6.0.0-1
- Change passed domain_name parameter value (rhbz#1718211)

* Fri Dec 20 2019 OSP Prod Chain <dev-null@redhat.com> 6.0.0-1
- Update patches
- Only set "unknown" in LSP that makes sense

* Wed Dec 18 2019 OSP Prod Chain <dev-null@redhat.com> 6.0.0-1
- Update patches
- Functional tests: Fix setup error due to missing function
- Fix pep8 errors found by hacking 2.0.0

* Fri Dec 13 2019 OSP Prod Chain <dev-null@redhat.com> 6.0.0-1
- Update patches
- Merge "Remove escape characters from container command" into stable/stein
- Remove escape characters from container command

* Mon Dec 09 2019 OSP Prod Chain <dev-null@redhat.com> 6.0.0-1
- Update patches
- Merge "Do not import networking_ovn.ovsdb.worker in impl_idl_ovn" into stable/stein
- Do not import networking_ovn.ovsdb.worker in impl_idl_ovn

* Mon Dec 09 2019 OSP Prod Chain <dev-null@redhat.com> 6.0.0-1
- Update patches
- Merge "Fallback to default network_driver value if octavia not present" into stable/stein
- Fallback to default network_driver value if octavia not present

* Wed Dec 04 2019 OSP Prod Chain <dev-null@redhat.com> 6.0.0-1
- Update patches
- Merge "Initialize TLS prior to retrieving OVSDB schema" into stable/stein
- Initialize TLS prior to retrieving OVSDB schema

* Thu Nov 28 2019 OSP Prod Chain <dev-null@redhat.com> 6.0.0-1
- Update patches
- Merge "Enable tempest DNS tests" into stable/stein
- Enable tempest DNS tests

* Wed Nov 27 2019 OSP Prod Chain <dev-null@redhat.com> 6.0.0-1
- Update patches
- Merge "ovn-metadata-agent: dsvm-functional issues due to str conversion" into stable/stein
- Merge "[metadata-agent] Fix issue with TLS/SSL connections" into stable/stein
- ovn-metadata-agent: dsvm-functional issues due to str conversion
- [metadata-agent] Fix issue with TLS/SSL connections

* Wed Nov 27 2019 OSP Prod Chain <dev-null@redhat.com> 6.0.0-1
- Update patches
- Merge "Update local.conf.sample to match stable/stein" into stable/stein
- Update local.conf.sample to match stable/stein

* Mon Nov 18 2019 OSP Prod Chain <dev-null@redhat.com> 6.0.0-1
- Update patches
- Merge "Support for Router Scheduling on addition/removal of chassis" into stable/stein
- Support for Router Scheduling on addition/removal of chassis

* Mon Nov 18 2019 OSP Prod Chain <dev-null@redhat.com> 6.0.0-1
- Update patches
- Add missing unittests to OVN provider driver

* Fri Oct 18 2019 OSP Prod Chain <dev-null@redhat.com> 6.0.0-1
- Update patches
- Merge "Avoid port group creation race" into stable/stein
- Avoid port group creation race

* Thu Oct 17 2019 OSP Prod Chain <dev-null@redhat.com> 6.0.0-1
- Update patches
- Merge "Set binding profile directly from OVNTrunkDriver (redo)" into stable/stein
- Set binding profile directly from OVNTrunkDriver (redo)

* Wed Oct 16 2019 OSP Prod Chain <dev-null@redhat.com> 6.0.0-1
- Update patches
- Merge "Disable ip_version checking while updating member without new ip" into stable/stein
- Merge "Add _find_ovn_lb_by_id() in OvnProviderHelper" into stable/stein
- Disable ip_version checking while updating member without new ip
- Add _find_ovn_lb_by_id() in OvnProviderHelper

* Wed Oct 16 2019 OSP Prod Chain <dev-null@redhat.com> 6.0.0-1
- Update patches
- Merge "Don't allow mixing IPv4/IPv6 configuration" into stable/stein
- Don't allow mixing IPv4/IPv6 configuration

* Mon Oct 14 2019 OSP Prod Chain <dev-null@redhat.com> 6.0.0-1
- Update patches
- Merge "Do not lose router logical port upon subnet add on the external net" into stable/stein
- Do not lose router logical port upon subnet add on the external net

* Mon Oct 14 2019 OSP Prod Chain <dev-null@redhat.com> 6.0.0-1
- Update patches
- Merge "Add specified vip address when create vip" into stable/stein
- Add specified vip address when create vip

* Tue Oct 08 2019 OSP Prod Chain <dev-null@redhat.com> 6.0.0-1
- Update patches
- Merge "Add unit test for metadata agent" into stable/stein
- Add unit test for metadata agent

* Wed Apr 10 2019 RDO <dev@lists.rdoproject.org> 6.0.0-1
- Update to 6.0.0

* Fri Mar 22 2019 RDO <dev@lists.rdoproject.org> 6.0.0-0.1.0rc1
- Update to 6.0.0.0rc1

